package minenet

import (
	"fmt"

	"wartank/pkg/components/sectionnet"
	"wartank/pkg/types"
)

/*
	Опрашивает шахту в сети
*/

// MineNet -- опрашивает шахту на базе
type MineNet struct {
	*sectionnet.SectionNet
	server types.IServer
	bot    types.IServBot
}

// NewMineNet -- возвращает новый *MineNet
func NewMineNet(server types.IServer, bot types.IServBot) (*MineNet, error) {
	{ // Предусловия
		if server == nil {
			return nil, fmt.Errorf("NewMineNet(): IServer == nil")
		}
		if bot == nil {
			return nil, fmt.Errorf("NewMineNet(): IServBot == nil")
		}
	}

	sf := &MineNet{
		server: server,
		bot:    bot,
	}
	return sf, nil
}

func (sf *MineNet) Run() error {
	sf.SectionNet = sectionnet.NewSectionNet(sf.server, sf.bot, sf.bot.Angar().Base().Mine(), "http://wartank.ru/production/Mine")
	return nil
}
